;________________________________________________________________________
;
;                           S E R I A L . A S M
;________________________________________________________________________
;
; Serial routine for PIC16C84 - Rx at 9600bd - By Max IK3SVW - Jan 2006
; Based on original picedia2 package by Byon Garrabrant, N6BG
;________________________________________________________________________

	cblock				; variables
		serialDelayCount
		serialCount
		serialData
	endc
;________________________________________________________________________

#define		SERIAL_IN	PORTA, 0
#define		SERIAL_OUT	PORTA, 1

#define	SERIAL_CLOCK_SPEED	D'10000000'
#define	SERIAL_BAUD_RATE	D'9600'

#define	_SBR			SERIAL_BAUD_RATE
#define	_SCS			SERIAL_CLOCK_SPEED
#define	DELAY_TIME	((((_SCS/4+_SBR/2)/_SBR)-D'10'+1)/3)

;________________________________________________________________________

serialReceive
	btfss	SERIAL_IN		; Check for Start bit
	 goto serialReceive		; not receiving now
	movlw	D'9'			
	movwf	serialCount		; gonna read 9 bits
	movlw	DELAY_TIME/3
	movwf	serialDelayCount	; Count down from DELAY_TIME/3
	decfsz	serialDelayCount, F	; Countdown
	 goto	$-1			; keep counting
serialReceiveLoop
	clrc				; assume clear carry
	btfss	SERIAL_IN		; if receiving 0
	 setc				; set carry
	rrf	serialData, F		; roll serialData bits	
	movlw	DELAY_TIME
	movwf	serialDelayCount	; Count down from DELAY_TIME
	decfsz	serialDelayCount, F	; Countdown
	 goto	$-1			; keep counting
	nop				; keep timing w/ transmit
	nop				; keep timing w/ transmit
	decfsz	serialCount, F		; if not complete
	 goto	serialReceiveLoop	; loop back for more
	movfw	serialData		; return the data
	return
